local CreateFrame, Elements, GetRuneCooldown, LibStub, UIParent, UnitFrame, idTweaks, idTweaksModule, idTweaksUtils, oUF, LibSharedMedia, shared_media_status_bars, shared_media_status_bars_reversed, shared_media_fonts, shared_media_fonts_reversed, shared_media_backgrounds, shared_media_backgrounds_reversed, TL, TC, TR, ML, MC, MR, BL, BC, BR, UnitFrames
do
  local _obj_0 = _G
  CreateFrame, Elements, GetRuneCooldown, LibStub, UIParent, UnitFrame, idTweaks, idTweaksModule, idTweaksUtils, oUF = _obj_0.CreateFrame, _obj_0.Elements, _obj_0.GetRuneCooldown, _obj_0.LibStub, _obj_0.UIParent, _obj_0.UnitFrame, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksUtils, _obj_0.oUF
end
LibSharedMedia = LibStub("LibSharedMedia-3.0")
shared_media_status_bars = LibSharedMedia:HashTable("statusbar")
shared_media_status_bars_reversed = idTweaksUtils.table.map.reverse(shared_media_status_bars)
shared_media_fonts = LibSharedMedia:HashTable("font")
shared_media_fonts_reversed = idTweaksUtils.table.map.reverse(shared_media_fonts)
shared_media_backgrounds = LibSharedMedia:HashTable("background")
shared_media_backgrounds_reversed = idTweaksUtils.table.map.reverse(shared_media_backgrounds)
TL, TC, TR = "TOPLEFT", "TOP", "TOPRIGHT"
ML, MC, MR = "LEFT", "CENTER", "RIGHT"
BL, BC, BR = "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT"
oUF.Tags.Methods.runes = function(unit, real_unit)
  if not (unit == "player") then
    return 
  end
  local amount = 0
  for i = 1, 6 do
    local _, ready
    _, _, ready = GetRuneCooldown(i)
    if ready == true then
      amount = amount + 1
    end
  end
  return amount
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    default = {
      enabled = true,
      frame = {
        size = {
          width = 250,
          height = 40,
          padding = 0,
          margin = 0
        },
        positioning = {
          from = "CENTER",
          target = "UIParent",
          to = "CENTER",
          x = 0,
          y = 0
        },
        background_texture = "",
        border_texture = "",
        border_insets = {
          top = 0,
          left = 0,
          right = 0,
          bottom = 0
        }
      },
      bars = {
        health_bar = {
          enabled = true,
          height = 0.6,
          texture = "Interface\\TargetingFrame\\UI-StatusBar",
          background = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
          border_texture = "",
          border_insets = {
            top = 0,
            left = 0,
            right = 0,
            bottom = 0
          }
        },
        power_bar = {
          enabled = true,
          height = 0.2,
          texture = "Interface\\TargetingFrame\\UI-StatusBar",
          background = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
          border_texture = "",
          border_insets = {
            top = 0,
            left = 0,
            right = 0,
            bottom = 0
          }
        },
        cast_bar = {
          enabled = true,
          height = 0.2,
          texture = "Interface\\TargetingFrame\\UI-StatusBar",
          background = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
          border_texture = "",
          border_insets = {
            top = 0,
            left = 0,
            right = 0,
            bottom = 0
          }
        },
        additional_power_bar = {
          enabled = false,
          height = 0.2,
          texture = "Interface\\TargetingFrame\\UI-StatusBar",
          background = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
          border_texture = "",
          border_insets = {
            top = 0,
            left = 0,
            right = 0,
            bottom = 0
          }
        }
      },
      buffs = {
        buffs = {
          rows = 2,
          columns = 8
        },
        debuffs = {
          rows = 2,
          columns = 8
        }
      },
      text = {
        name = {
          padding = 5,
          font = "Fonts\\FRIZQT__.TTF",
          color = {
            r = 1.0,
            g = 1.0,
            b = 1.0,
            a = 1.0
          },
          tag = "[name][leader][status][threatcolor][threat]"
        },
        health = {
          padding = 5,
          font = "Fonts\\FRIZQT__.TTF",
          color = {
            r = 1.0,
            g = 1.0,
            b = 1.0,
            a = 1.0
          },
          tag = "[curhp]"
        },
        classpower = {
          padding = 5,
          font = "Fonts\\FRIZQT__.TTF",
          color = {
            r = 1.0,
            g = 1.0,
            b = 1.0,
            a = 1.0
          },
          tag = "[runes][arcanecharges][chi][holypower][soulshards][cpoints]"
        },
        power = {
          padding = 5,
          font = "Fonts\\FRIZQT__.TTF",
          color = {
            r = 1.0,
            g = 1.0,
            b = 1.0,
            a = 1.0
          },
          tag = "[curpp]"
        }
      }
    },
    units = {
      "pet",
      "player",
      "target",
      "targettarget"
    },
    set_defaults = function(self)
      self.defaults = {
        profile = {
          enabled = true,
          layout = "horizontal",
          default = self.default,
          pet = idTweaksUtils.table.map.merge(self.default, {
            defaults = true
          }),
          player = idTweaksUtils.table.map.merge(self.default, {
            defaults = true
          }),
          target = idTweaksUtils.table.map.merge(self.default, {
            defaults = true
          }),
          targettarget = idTweaksUtils.table.map.merge(self.default, {
            defaults = true
          }),
          party = idTweaksUtils.table.map.merge(self.default, {
            defaults = true
          })
        }
      }
    end,
    get_unit_options = function(self, unit, unit_name)
      local unit_has_defaults
      unit_has_defaults = function(unit)
        return function()
          return not not self.db[unit].defaults
        end
      end
      return self:create_group(unit, unit_name, unit_name, {
        defaults = self:create_toggle(tostring(unit) .. ".defaults", "Defaults", "Use Default Unit options for this unit", {
          order = 0
        }),
        frame = self:create_group(tostring(unit) .. ".frame", "Frame", "Settings that affect the Frame", {
          order = 1,
          disabled = unit_has_defaults(unit),
          size = self:create_group(tostring(unit) .. ".frame.size", "Size", "Control the size of the frame", {
            order = 1,
            disabled = unit_has_defaults(unit),
            width = self:create_range(tostring(unit) .. ".frame.size.width", "Width", "Width of the frame", {
              order = 1,
              min = 100,
              max = 1000,
              step = 1,
              bigStep = 10,
              set = function(_, value)
                self.db[unit].frame.size.width = value
                for i, unit in ipairs(self.units) do
                  self:size_position_frame(unit, self.frames[unit])
                  self:size_position_elements(unit, self.frames[unit])
                end
              end
            }),
            height = self:create_range(tostring(unit) .. ".frame.size.height", "Height", "Height of the frame", {
              order = 2,
              min = 5,
              max = 100,
              step = 1,
              bigStep = 1,
              set = function(_, value)
                self.db[unit].frame.size.height = value
                for i, unit in ipairs(self.units) do
                  self:size_position_frame(unit, self.frames[unit])
                  self:size_position_elements(unit, self.frames[unit])
                end
              end
            }),
            padding = self:create_range(tostring(unit) .. ".frame.size.padding", "Padding", "Padding of the frame", {
              order = 3,
              min = 0,
              max = 100,
              step = 1,
              bigStep = 1,
              set = function(_, value)
                self.db[unit].frame.size.padding = value
                for i, unit in ipairs(self.units) do
                  self:size_position_frame(unit, self.frames[unit])
                  self:size_position_elements(unit, self.frames[unit])
                end
              end
            }),
            margin = self:create_range(tostring(unit) .. ".frame.size.margin", "Margin", "Margin of the frame", {
              order = 4,
              min = 0,
              max = 100,
              step = 1,
              bigStep = 1,
              set = function(_, value)
                self.db[unit].frame.size.margin = value
                for i, unit in ipairs(self.units) do
                  self:size_position_frame(unit, self.frames[unit])
                  self:size_position_elements(unit, self.frames[unit])
                end
              end
            })
          }),
          positioning = self:create_group(tostring(unit) .. ".frame.positioning", "Positioning", "Control the positioning of the frame", {
            order = 2,
            disabled = unit_has_defaults(unit)
          })
        }),
        bars = self:create_group(tostring(unit) .. ".bars", "Bars", "Settings that affect the Bars", {
          order = 2,
          disabled = unit_has_defaults(unit),
          health_bar = self:create_group(tostring(unit) .. ".bars.health_bar", "Health Bar", "Health Bar", {
            order = 1,
            disabled = unit_has_defaults(unit),
            enabled = self:create_toggle(tostring(unit) .. ".bars.health_bar.enabled", "Enabled", "Turns the bar on and off", {
              order = 0
            }),
            texture = self:create_select(tostring(unit) .. ".bars.health_bar.texture", "Texture", "Texture", {
              order = 1,
              dialogControl = "LSM30_Statusbar",
              values = LibSharedMedia:HashTable("statusbar"),
              set = function(_, value)
                self.db[unit].bars.health_bar.texture = shared_media_status_bars[value]
                return self:update_all_units()
              end
            }),
            background = self:create_select(tostring(unit) .. ".bars.health_bar.background", "Background", "Background", {
              order = 2,
              dialogControl = "LSM30_Statusbar",
              values = LibSharedMedia:HashTable("statusbar"),
              set = function(_, value)
                self.db[unit].bars.health_bar.background = shared_media_status_bars[value]
                return self:update_all_units()
              end
            }),
            height = self:create_range(tostring(unit) .. ".bars.health_bar.height", "Height", "Height of the frame", {
              order = 3,
              min = 0.1,
              max = 2.0,
              step = 0.1,
              bigStep = 0.5,
              set = function(_, value)
                self.db[unit].bars.health_bar.height = value
                return self:update_all_units()
              end
            })
          }),
          power_bar = self:create_group(tostring(unit) .. ".bars.power_bar", "Power Bar", "Power Bar", {
            order = 2,
            disabled = unit_has_defaults(unit),
            enabled = self:create_toggle(tostring(unit) .. ".bars.power_bar.enabled", "Enabled", "Turns the bar on and off", {
              order = 0
            }),
            texture = self:create_select(tostring(unit) .. ".bars.power_bar.texture", "Texture", "Texture", {
              order = 1,
              dialogControl = "LSM30_Statusbar",
              values = LibSharedMedia:HashTable("statusbar"),
              set = function(_, value)
                self.db[unit].bars.power_bar.texture = shared_media_status_bars[value]
                return self:update_all_units()
              end
            }),
            background = self:create_select(tostring(unit) .. ".bars.power_bar.background", "Background", "Background", {
              order = 2,
              dialogControl = "LSM30_Statusbar",
              values = LibSharedMedia:HashTable("statusbar"),
              set = function(_, value)
                self.db[unit].bars.power_bar.background = shared_media_status_bars[value]
                return self:update_all_units()
              end
            }),
            height = self:create_range(tostring(unit) .. ".bars.power_bar.height", "Height", "Height of the frame", {
              order = 3,
              min = 0.1,
              max = 2.0,
              step = 0.1,
              bigStep = 0.5,
              set = function(_, value)
                self.db[unit].bars.power_bar.height = value
                return self:update_all_units()
              end
            })
          }),
          cast_bar = self:create_group(tostring(unit) .. ".bars.cast_bar", "Cast Bar", "Cast Bar", {
            order = 2,
            enabled = self:create_toggle(tostring(unit) .. ".bars.cast_bar.enabled", "Enabled", "Turns the bar on and off", {
              order = 1
            })
          }),
          additional_power_bar = self:create_group(tostring(unit) .. ".bars.additional_power_bar", "Additional Power Bar", "Additional Power Bar", {
            order = 2,
            disabled = unit_has_defaults(unit),
            enabled = self:create_toggle(tostring(unit) .. ".bars.additional_power_bar.enabled", "Enabled", "Turns the bar on and off", {
              order = 0
            }),
            texture = self:create_select(tostring(unit) .. ".bars.additional_power_bar.texture", "Texture", "Texture", {
              order = 1,
              dialogControl = "LSM30_Statusbar",
              values = LibSharedMedia:HashTable("statusbar"),
              set = function(_, value)
                self.db[unit].bars.additional_power_bar.texture = shared_media_status_bars[value]
                return self:update_all_units()
              end
            }),
            background = self:create_select(tostring(unit) .. ".bars.additional_power_bar.background", "Background", "Background", {
              order = 2,
              dialogControl = "LSM30_Statusbar",
              values = LibSharedMedia:HashTable("statusbar"),
              set = function(_, value)
                self.db[unit].bars.additional_power_bar.background = shared_media_status_bars[value]
                return self:update_all_units()
              end
            }),
            height = self:create_range(tostring(unit) .. ".bars.additional_power_bar.height", "Height", "Height of the frame", {
              order = 3,
              min = 0.1,
              max = 2.0,
              step = 0.1,
              bigStep = 0.5,
              set = function(_, value)
                self.db[unit].bars.additional_power_bar.height = value
                return self:update_all_units()
              end
            })
          })
        }),
        buffs = self:create_group(tostring(unit) .. ".buffs", "Buffs", "Settings that affect the Buffs", {
          order = 3,
          disabled = unit_has_defaults(unit),
          buffs = self:create_group(tostring(unit) .. ".buffs.buffs", "Buffs", "Buffs", {
            order = 1,
            disabled = unit_has_defaults(unit),
            rows = self:create_range(tostring(unit) .. ".buffs.buffs.rows", "Rows", "Number of Rows", {
              order = 1,
              min = 1,
              max = 10,
              step = 1,
              bigStep = 5,
              set = function(_, value)
                self.db[unit].buffs.buffs.rows = value
                return self:update_all_units()
              end
            }),
            columns = self:create_range(tostring(unit) .. ".buffs.buffs.columns", "Columns", "Number of Columns", {
              order = 1,
              min = 1,
              max = 10,
              step = 1,
              bigStep = 5,
              set = function(_, value)
                self.db[unit].buffs.buffs.columns = value
                return self:update_all_units()
              end
            })
          }),
          debuffs = self:create_group(tostring(unit) .. ".buffs.debuffs", "Debuffs", "Debuffs", {
            order = 2,
            disabled = unit_has_defaults(unit),
            rows = self:create_range(tostring(unit) .. ".buffs.debuffs.rows", "Rows", "Number of Rows", {
              order = 1,
              min = 1,
              max = 10,
              step = 1,
              bigStep = 5,
              set = function(_, value)
                self.db[unit].buffs.debuffs.rows = value
                return self:update_all_units()
              end
            }),
            columns = self:create_range(tostring(unit) .. ".buffs.debuffs.columns", "Columns", "Number of Columns", {
              order = 1,
              min = 1,
              max = 10,
              step = 1,
              bigStep = 5,
              set = function(_, value)
                self.db[unit].buffs.debuffs.columns = value
                return self:update_all_units()
              end
            })
          })
        }),
        text = self:create_group(tostring(unit) .. ".text", "Text", "Text", {
          order = 4,
          disabled = unit_has_defaults(unit),
          name = self:create_group(tostring(unit) .. ".text.name", "Name", "Name", {
            order = 1,
            padding = self:create_range(tostring(unit) .. ".text.name.padding", "Padding", "Padding", {
              order = 1,
              min = 1,
              max = 10,
              step = 1,
              bigStep = 5,
              set = function(_, value)
                self.db[unit].text.name.padding = value
                return self:update_all_units()
              end
            }),
            font = self:create_select(tostring(unit) .. ".text.name.font", "Font", "Font", {
              order = 1,
              dialogControl = "LSM30_Font",
              values = shared_media_fonts,
              set = function(_, value)
                self.db[unit].text.name.font = shared_media_fonts[value]
                return self:update_all_units()
              end
            })
          })
        })
      })
    end,
    set_options = function(self)
      print("UnitFrames#set_options")
      _class_0.__parent.__base.set_options(self)
      self.options.args.layout = self:create_select("layout", "Layout", "Switch layouts", {
        order = 1,
        values = {
          horizontal = "Horizontal",
          vertical = "Vertical"
        },
        set = function(_, value)
          self.db.layout = value
          return self:update_all_units()
        end
      })
      self.options.args.default = self:get_unit_options("default", "Default")
      self.options.args.default.args.defaults = nil
      self.options.args.pet = self:get_unit_options("pet", "Pet")
      self.options.args.player = self:get_unit_options("player", "Player")
      self.options.args.target = self:get_unit_options("target", "Target")
      self.options.args.targettarget = self:get_unit_options("targettarget", "Targettarget")
    end,
    initialize = function(self)
      oUF:RegisterStyle("idTweaks_default", function(frame, unit)
        return self:layout_default(unit, frame)
      end)
      return oUF:SetActiveStyle("idTweaks_default")
    end,
    enable = function(self)
      self.frames.player = oUF:Spawn("player")
      self.frames.pet = oUF:Spawn("pet")
      self.frames.target = oUF:Spawn("target")
      self.frames.targettarget = oUF:Spawn("targettarget")
      local add_frame
      add_frame = function(unit)
        local db = self:get_db_for_unit(unit)
        self.frames1[unit] = UnitFrame(unit)
        for k, v in pairs(db.bars) do
          self.frames1[unit]:add_bar(Elements.bars[v])
        end
        for k, v in pairs(db.indicators) do
          self.frames1[unit]:add_indicator(Elements.indicators[v])
        end
      end
      add_frame("player")
      add_frame("pet")
      add_frame("target")
      return add_frame("targettarget")
    end,
    get_default_or_unit_setter = function(self, fn)
      return function(self, unit, ...)
        if unit ~= "default" then
          return fn(unit, ...)
        end
        for name, frame in pairs(self.frames) do
          if self.db[name].defaults then
            fn(name, ...)
          end
        end
      end
    end,
    get_db_for_unit = function(self, unit)
      local db_unit = self.db[unit]
      assert(db_unit, "Unit not found: " .. tostring(unit))
      if db_unit.defaults then
        return self.db.default
      else
        return db_unit
      end
    end,
    get_enabled_bars = function(self, unit)
      local db = self:get_db_for_unit(unit)
      local bars = { }
      if db.bars.health_bar.enabled then
        table.insert(bars, "health_bar")
      end
      if db.bars.power_bar.enabled then
        table.insert(bars, "power_bar")
      end
      if db.bars.cast_bar.enabled then
        table.insert(bars, "cast_bar")
      end
      return bars
    end,
    get_weights_total = function(self, unit)
      local db = self:get_db_for_unit(unit)
      return idTweaksUtils.table.list.reduce((function(a, v)
        return a + db.bars[v].height
      end), (self:get_enabled_bars(unit)), 0)
    end,
    size_position_frame = function(self, unit, frame)
      local layout
      layout = self.db.layout
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      local _exp_0 = layout
      if "horizontal" == _exp_0 then
        local _exp_1 = unit
        if "player" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(MR, UIParent, MC, -db.frame.size.margin / 2, -200)
        elseif "target" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(ML, UIParent, MC, db.frame.size.margin / 2, -200)
        elseif "targettarget" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(ML, self.frames.target, MR, db.frame.size.margin, 0)
        elseif "pet" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(MR, self.frames.player, ML, -db.frame.size.margin, 0)
        else
          return print("Unknown unit: " .. tostring(unit))
        end
      elseif "vertical" == _exp_0 then
        local _exp_1 = unit
        if "player" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(MC, UIParent, MC, 0, -200)
        elseif "target" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(BC, self.frames.player, TC, 0, db.frame.size.margin)
        elseif "targettarget" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(BC, self.frames.target, TC, 0, db.frame.size.margin)
        elseif "pet" == _exp_1 then
          frame:ClearAllPoints()
          return frame:SetPoint(TC, self.frames.player, BC, 0, -db.frame.size.margin)
        else
          return print("Unknown unit: " .. tostring(unit))
        end
      else
        return print("Unknown layout: " .. tostring(layout))
      end
    end,
    size_position_elements = function(self, unit, frame)
      local layout
      layout = self.db.layout
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      frame:SetWidth(db.frame.size.width)
      frame:SetHeight(db.frame.size.height)
      local _exp_0 = layout
      if "horizontal" == _exp_0 then
        local number_of_bars = #self:get_enabled_bars(unit)
        local weights_total = self:get_weights_total(unit)
        local width_minus_padding = db.frame.size.width - db.frame.size.padding * 2
        local height_minus_padding = db.frame.size.height - db.frame.size.padding * number_of_bars + 1
        if db.bars.health_bar.enabled then
          frame.Health:SetWidth(width_minus_padding)
          frame.Health:SetHeight(height_minus_padding / weights_total * db.bars.health_bar.height)
          frame.Health:ClearAllPoints()
          frame.Health:SetPoint(TC, frame, TC, 0, -db.frame.size.padding)
        end
        if db.bars.power_bar.enabled then
          frame.Power:SetWidth(width_minus_padding)
          frame.Power:SetHeight(height_minus_padding / weights_total * db.bars.power_bar.height)
          frame.Power:ClearAllPoints()
          frame.Power:SetPoint(TC, frame.Health, BC, 0, -db.frame.size.padding)
        end
        if db.bars.cast_bar.enabled then
          frame.Castbar:SetWidth(width_minus_padding)
          frame.Castbar:SetHeight(height_minus_padding / weights_total * db.bars.cast_bar.height)
          frame.Castbar.Icon:SetSize(frame.Castbar:GetHeight(), frame.Castbar:GetHeight())
          frame.Castbar.Shield:SetSize(frame.Castbar:GetHeight(), frame.Castbar:GetHeight())
          frame.Castbar:ClearAllPoints()
          frame.Castbar:SetPoint(TC, frame.Power, BC, 0, -db.frame.size.padding)
        end
        if db.bars.additional_power_bar.enabled then
          frame.AdditionalPower:SetWidth(width_minus_padding)
          frame.AdditionalPower:SetHeight(height_minus_padding / weights_total * db.bars.additional_power_bar.height)
          frame.AdditionalPower:ClearAllPoints()
          frame.AdditionalPower:SetPoint(TC, frame.Power, BC, 0, -db.frame.size.padding)
        end
        frame.Buffs.size = db.frame.size.height / db.buffs.buffs.rows
        frame.Buffs.initialAnchor = BL
        frame.Buffs["growth-x"] = "RIGHT"
        frame.Buffs["growth-y"] = "UP"
        frame.Buffs:SetSize(db.buffs.buffs.columns * frame.Buffs.size, db.buffs.buffs.rows * frame.Buffs.size)
        frame.Buffs:ClearAllPoints()
        frame.Buffs:SetPoint(BL, frame, TL, 0, db.frame.size.padding)
        frame.Debuffs.size = db.frame.size.height / db.buffs.debuffs.rows
        frame.Debuffs.initialAnchor = TL
        frame.Debuffs["growth-x"] = "RIGHT"
        frame.Debuffs["growth-y"] = "DOWN"
        frame.Debuffs:SetSize(db.buffs.debuffs.columns * frame.Debuffs.size, db.buffs.debuffs.rows * frame.Debuffs.size)
        frame.Debuffs:ClearAllPoints()
        return frame.Debuffs:SetPoint(TL, frame, BL, 0, -db.frame.size.padding)
      elseif "vertical" == _exp_0 then
        local number_of_bars = #self:get_enabled_bars(unit)
        local weights_total = self:get_weights_total(unit)
        local width_minus_padding = db.frame.size.width - db.frame.size.padding * 2
        local height_minus_padding = db.frame.size.height - db.frame.size.padding * number_of_bars + 1
        if db.bars.health_bar.enabled then
          frame.Health:SetWidth(width_minus_padding)
          frame.Health:SetHeight(height_minus_padding / weights_total * db.bars.health_bar.height)
          frame.Health:ClearAllPoints()
          frame.Health:SetPoint(TC, frame, TC, 0, -db.frame.size.padding)
        end
        if db.bars.power_bar.enabled then
          frame.Power:SetWidth(width_minus_padding)
          frame.Power:SetHeight(height_minus_padding / weights_total * db.bars.power_bar.height)
          frame.Power:ClearAllPoints()
          frame.Power:SetPoint(TC, frame.Health, BC, 0, -db.frame.size.padding)
        end
        if db.bars.cast_bar.enabled then
          frame.Castbar:SetWidth(width_minus_padding)
          frame.Castbar:SetHeight(height_minus_padding / weights_total * db.bars.cast_bar.height)
          frame.Castbar.Icon:SetSize(frame.Castbar:GetHeight(), frame.Castbar:GetHeight())
          frame.Castbar.Shield:SetSize(frame.Castbar:GetHeight(), frame.Castbar:GetHeight())
          frame.Castbar:ClearAllPoints()
          frame.Castbar:SetPoint(TC, frame.Power, BC, 0, -db.frame.size.padding)
        end
        if db.bars.additional_power_bar.enabled then
          frame.AdditionalPower:SetWidth(width_minus_padding)
          frame.AdditionalPower:SetHeight(height_minus_padding / weights_total * db.bars.additional_power_bar.height)
          frame.AdditionalPower:ClearAllPoints()
          frame.AdditionalPower:SetPoint(TC, frame.Power, BC, 0, -db.frame.size.padding)
        end
        frame.Buffs.size = db.frame.size.height / db.buffs.buffs.rows
        frame.Buffs.initialAnchor = TR
        frame.Buffs["growth-x"] = "LEFT"
        frame.Buffs["growth-y"] = "DOWN"
        frame.Buffs:SetSize(db.buffs.buffs.columns * frame.Buffs.size, db.buffs.buffs.rows * frame.Buffs.size)
        frame.Buffs:ClearAllPoints()
        frame.Buffs:SetPoint(TR, frame, TL, -db.frame.size.padding, 0)
        frame.Debuffs.size = db.frame.size.height / db.buffs.debuffs.rows
        frame.Debuffs.initialAnchor = TL
        frame.Debuffs["growth-x"] = "RIGHT"
        frame.Debuffs["growth-y"] = "DOWN"
        frame.Debuffs:SetSize(db.buffs.debuffs.columns * frame.Debuffs.size, db.buffs.buffs.rows * frame.Debuffs.size)
        frame.Debuffs:ClearAllPoints()
        return frame.Debuffs:SetPoint(TL, frame, TR, db.frame.size.padding, 0)
      else
        return print("Unknown layout: " .. tostring(layout))
      end
    end,
    health_bar_set_texture = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      return frame.Health:SetStatusBarTexture(db.bars.health_bar.texture)
    end,
    health_bar_set_background = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      frame.Health.bg:SetTexture(db.bars.health_bar.background)
      frame.Health.bg.multiplier = 0.5
    end,
    power_bar_set_texture = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      return frame.Power:SetStatusBarTexture(db.bars.power_bar.texture)
    end,
    power_bar_set_background = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      frame.Power.bg:SetTexture(db.bars.power_bar.background)
      frame.Power.bg.multiplier = 0.5
    end,
    cast_bar_set_texture = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      return frame.Castbar:SetStatusBarTexture(db.bars.cast_bar.texture)
    end,
    cast_bar_set_background = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      frame.Castbar.bg:SetTexture(db.bars.cast_bar.background)
      frame.Castbar.bg.multiplier = 0.5
    end,
    additional_power_bar_set_texture = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      return frame.AdditionalPower:SetStatusBarTexture(db.bars.additional_power_bar.texture)
    end,
    additional_power_bar_set_background = function(self, unit, frame)
      frame = frame or self.frames[unit]
      local db = self:get_db_for_unit(unit)
      frame.AdditionalPower.bg:SetTexture(db.bars.additional_power_bar.background)
      frame.AdditionalPower.bg.multiplier = 0.5
    end,
    create_background = function(self, unit, frame)
      frame.background = frame:CreateTexture(nil, "BACKGROUND")
      frame.background:SetAllPoints(frame)
      return frame.background:SetColorTexture(0, 0, 0, 0.5)
    end,
    create_healthbar = function(self, unit, frame)
      local Health = CreateFrame("StatusBar", nil, frame)
      Health.frequentUpdates = true
      Health.colorTapping = true
      Health.colorDisconnected = true
      Health.colorClass = true
      Health.colorReaction = true
      Health.colorHealth = true
      Health.bg = Health:CreateTexture(nil, "BORDER")
      Health.bg:SetAllPoints(Health)
      frame.Health = Health
    end,
    create_powerbar = function(self, unit, frame)
      local Power = CreateFrame("StatusBar", nil, frame)
      Power.frequentUpdates = true
      Power.colorPower = true
      Power.bg = Power:CreateTexture(nil, "BORDER")
      Power.bg:SetAllPoints(Power)
      frame.Power = Power
    end,
    create_cast_bar = function(self, unit, frame)
      local Castbar = CreateFrame("StatusBar", nil, frame)
      Castbar.timeToHold = 0
      Castbar.hideTradeSkills = false
      Castbar.bg = Castbar:CreateTexture(nil, "BACKGROUND")
      Castbar.bg:SetAllPoints(Castbar)
      Castbar.Spark = Castbar:CreateTexture(nil, "OVERLAY")
      Castbar.Spark:SetBlendMode("ADD")
      Castbar.Spark:SetPoint(MC, Castbar:GetStatusBarTexture(), MR, 0, 0)
      Castbar.Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
      Castbar.Time:SetPoint(MR, Castbar, MR, 0, 0)
      Castbar.Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
      Castbar.Text:SetPoint(ML, Castbar, ML, 0, 0)
      Castbar.Icon = Castbar:CreateTexture(nil, "OVERLAY")
      Castbar.Shield = Castbar:CreateTexture(nil, "OVERLAY")
      Castbar.Shield:SetPoint(MC, Castbar, MC, 0, 0)
      Castbar.SafeZone = Castbar:CreateTexture(nil, "OVERLAY")
      frame.Castbar = Castbar
    end,
    create_additional_powerbar = function(self, unit, frame)
      local AdditionalPower = CreateFrame("StatusBar", nil, frame)
      AdditionalPower.frequentUpdates = true
      AdditionalPower.colorPower = true
      AdditionalPower.bg = AdditionalPower:CreateTexture(nil, "BORDER")
      AdditionalPower.bg:SetAllPoints(AdditionalPower)
      frame.AdditionalPower = AdditionalPower
    end,
    create_buffs = function(self, unit, frame)
      frame.Buffs = CreateFrame("Frame", nil, frame)
      frame.Buffs.num = 16
    end,
    create_debuffs = function(self, unit, frame)
      frame.Debuffs = CreateFrame("Frame", nil, frame)
      frame.Debuffs.num = 16
    end,
    create_nametext = function(self, unit, frame)
      local text_padding = 5
      frame.NameText = frame.Health:CreateFontString(nil, "OVERLAY", "GameFontNormal")
      frame.NameText:SetFont(frame.NameText:GetFont(), 9)
      frame.NameText:SetTextColor(1, 1, 1, 1)
      frame.NameText:SetPoint(ML, frame.Health, ML, text_padding, 0)
      frame.NameText:SetHeight(9)
      return frame:Tag(frame.NameText, "[name][leader][status][threatcolor][threat]|r")
    end,
    create_healthtext = function(self, unit, frame)
      local text_padding = 5
      frame.HealthText = frame.Health:CreateFontString(nil, "OVERLAY", "GameFontNormal")
      frame.HealthText:SetFont(frame.HealthText:GetFont(), 9)
      frame.HealthText:SetTextColor(1, 1, 1, 1)
      frame.HealthText:SetPoint(MR, frame.Health, MR, -text_padding, 0)
      frame.HealthText:SetHeight(9)
      return frame:Tag(frame.HealthText, "[curhp]")
    end,
    create_classpowertext = function(self, unit, frame)
      local text_padding = 5
      frame.ClassPowerText = frame.Power:CreateFontString(nil, "OVERLAY", "GameFontNormal")
      frame.ClassPowerText:SetFont(frame.ClassPowerText:GetFont(), 9)
      frame.ClassPowerText:SetTextColor(1, 1, 1, 1)
      frame.ClassPowerText:SetPoint(ML, frame.Power, ML, text_padding, 0)
      frame.ClassPowerText:SetHeight(9)
      return frame:Tag(frame.ClassPowerText, "[runes][arcanecharges][chi][holypower][soulshards][cpoints]")
    end,
    create_powertext = function(self, unit, frame)
      local text_padding = 5
      frame.PowerText = frame.Power:CreateFontString(nil, "OVERLAY", "GameFontNormal")
      frame.PowerText:SetFont(frame.PowerText:GetFont(), 9)
      frame.PowerText:SetTextColor(1, 1, 1, 1)
      frame.PowerText:SetPoint(MR, frame.Power, MR, -text_padding, 0)
      frame.PowerText:SetHeight(9)
      return frame:Tag(frame.PowerText, "[curpp]")
    end,
    create_unit = function(self, unit, frame)
      self:create_background(unit, frame)
      self:create_healthbar(unit, frame)
      self:create_powerbar(unit, frame)
      self:create_cast_bar(unit, frame)
      self:create_additional_powerbar(unit, frame)
      self:create_buffs(unit, frame)
      self:create_debuffs(unit, frame)
      self:create_nametext(unit, frame)
      self:create_healthtext(unit, frame)
      self:create_classpowertext(unit, frame)
      return self:create_powertext(unit, frame)
    end,
    update_unit = function(self, unit, frame)
      local db = self:get_db_for_unit(unit)
      self:size_position_elements(unit, frame)
      self:size_position_frame(unit, frame)
      if db.bars.health_bar.enabled then
        self:health_bar_set_texture(unit, frame)
        self:health_bar_set_background(unit, frame)
      end
      if db.bars.power_bar.enabled then
        self:power_bar_set_texture(unit, frame)
        self:power_bar_set_background(unit, frame)
      end
      if db.bars.cast_bar.enabled then
        self:cast_bar_set_texture(unit, frame)
        self:cast_bar_set_background(unit, frame)
      end
      if db.bars.additional_power_bar.enabled then
        self:additional_power_bar_set_texture(unit, frame)
        return self:additional_power_bar_set_background(unit, frame)
      end
    end,
    update_all_units = function(self)
      for i, unit in ipairs(self.units) do
        self:update_unit(unit, self.frames[unit])
      end
    end,
    layout_default = function(self, unit, frame)
      self:create_unit(unit, frame)
      return self:update_unit(unit, frame)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      _class_0.__parent.__init(self, addon, "UnitFrames", "AceConsole-3.0", "AceEvent-3.0")
      self.frames = { }
      self.frames1 = { }
      self.size = { }
    end,
    __base = _base_0,
    __name = "UnitFrames",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  UnitFrames = _class_0
end
return idTweaks:add_module(UnitFrames(idTweaks))
